function f_comp, t, p0
;function to generate fourier components
;p0=[m_0, Period, phase,alpha1, alpha2,..., beta1,beta2...]
;going to feed this into mpfit, so I want to keep everything double-precision
;Set everything up as 2-d arrays and use the total() function to avoid loops

newt=t-p0(2)  ;apply the phase shift

n_extra=3

;number of alpha elements
na=(n_elements(p0)-n_extra)/2
alphas=p0(n_extra:n_extra+na-1)
alphas=(newt*0+1)#alphas
betas=p0(n_extra+na:n_extra+2*na-1) ;number of betas should be the same as alphas
betas=(newt*0+1)#betas

tt=newt#(dblarr(na)+1.)   ;generate a big array for time
                              
k=(t*0+1) #(dindgen(na)+1) ;set up k-array

arg=(2.*!pi*k*tt/p0(1)) ;argument to get passed to sin and cos

result=alphas*sin(arg)+betas*cos(arg)
result=p0(0)+total(result,2)

;stop


return, result
end
