function period_simp, t, y, range=range, min_sl=min_sl, npts=npts, $
                      harms=harms, length=length
;given a time series of points, find the period that minimizes the
;      string length--danger, this does no checking to see if it hit a
; harmonic rather than the fundamental period.  Someone should really
; set this to recursivly check the returned period.--Hey, I went and
; did it, good for me.

time=t-min(t)
if not keyword_set(npts) then n=1000 else n=npts
np=n_elements(y)

if not keyword_set(range) then range=[min(time), max(time)]

;set up the folds to check
folds=dindgen(n)/(n-1)*(max(range)-min(range))+min(range)

;variable to hold the string length
sl=fltarr(n)

;fold up the light-curve and calc the string length, normally this
;     would be better done with something like a FT, but this data is
; usually irregularly sampled, so that makes FT harder

for i=0,n-1 do begin
  folded=fold(time,folds(i))
  order=sort(folded)
  lc=y(order) ;light curve ordered up
  lc2=shift(lc,-1)              ;pull the points back one spot
                                ;sl(i)=total(abs(lc-lc2)) ;and there's
                                ;the string length!, Hooray for not
                                ;writing loops!
  f2=shift(folded,-1)

  sl(i)=total(abs(lc-lc2)) ;total(sqrt( (folded-f2)^2+(lc-lc2)^2))        ;total(abs(lc-lc2))

endfor


min_sl=min(sl)
;danger, can return a huge array if the user supplied range is larger
;        than the actuall range and id doesn't find a good period



if keyword_set(harms) then begin  ;make sure harmonics are not shorter
  nh=10
  bf=max(folds(where(sl eq min(min_sl)))) ;best_fit so far
  folds=bf/(findgen(nh)+1)
  good=where(folds ge min(range))
  nh=n_elements(good)
  folds=folds(good)
  sl=fltarr(nh)
  for i=0,nh-1 do begin

    folded=fold(time,folds(i))
    order=sort(folded)
    lc=y(order)                 ;light curve ordered up
    lc2=shift(lc,-1)            ;pull the points back one spot
                                ;sl(i)=total(abs(lc-lc2)) ;and there's
                                ;the string length!, Hooray for not
                                ;writing loops!
   f2=shift(folded,-1)

   sl(i)= total(abs(lc-lc2));total(sqrt( (folded-f2)^2+(lc-lc2)^2))  ;sl(i)=total(abs(lc-lc2))
 
    min_sl=min(sl)
  endfor



endif


length=sl(where(sl eq min(min_sl)))


return, folds(where(sl eq min(min_sl)))


end
